﻿using Scully.Properties;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Media;

namespace Scully
{
    /// <summary>
    /// Interaction logic for App.xaml
    /// </summary>
    /// 

    public partial class App : Application
    {

        public bool changesPending = false;
        public MainWindow mainWindow;


        private void Application_Startup(object sender, StartupEventArgs e)
        {
            mainWindow = new MainWindow();
            LoadPreferences();

            mainWindow.Show();


            // listen for application events from MainWindow1: e.g. save/load/open/new
            // listen for application events from MainWindow1: ResetPreferences

        }

        private void LoadPreferences()
        {

            MainWindow m = mainWindow;

            //ResetPreferences();

            m.brushWindowBg = new SolidColorBrush(classes.ColorConverter.ToMediaColor(Settings.Default.brushWindowBg));

            m.brushCanvasFg = new SolidColorBrush(classes.ColorConverter.ToMediaColor(Settings.Default.brushCanvasFg));
            m.brushCanvasBg = new SolidColorBrush(classes.ColorConverter.ToMediaColor(Settings.Default.brushCanvasBg));
            m.brushCanvasHighlight = new SolidColorBrush(classes.ColorConverter.ToMediaColor(Settings.Default.brushCanvasHighlight));
            m.brushCanvasHighlightFg = new SolidColorBrush(classes.ColorConverter.ToMediaColor(Settings.Default.brushCanvasHighlightFg));
            m.brushCanvasBounds = new SolidColorBrush(classes.ColorConverter.ToMediaColor(Settings.Default.brushCanvasBounds));

            m.brushCaret = new SolidColorBrush(classes.ColorConverter.ToMediaColor(Settings.Default.brushCaret));

            m.brushInfobarFg = new SolidColorBrush(classes.ColorConverter.ToMediaColor(Settings.Default.brushInfobarFg));
            m.brushInfobarBg = new SolidColorBrush(classes.ColorConverter.ToMediaColor(Settings.Default.brushInfobarBg));

        }


        public static void ResetPreferences()
        {

            Settings.Default.Reset();

            #region Font Sizes
            Settings.Default.fontsizeCanvas = Settings.Default.fontsizeCanvasDefault;
            Settings.Default.fontsizeInfobar = Settings.Default.fontsizeInfobarDefault;
            #endregion

            #region Options
            Settings.Default.useSystemCaret = false;
            Settings.Default.displayPageBounds = false;
            Settings.Default.displayInfoBar = true;
            # endregion

            #region Colors
            Settings.Default.brushWindowBg = Settings.Default.brushWindowBgDefault;

            Settings.Default.brushCanvasFg = Settings.Default.brushCanvasFgDefault;
            Settings.Default.brushCanvasBg = Settings.Default.brushCanvasBgDefault;
            Settings.Default.brushCanvasHighlight = Settings.Default.brushCanvasHighlightDefault;
            Settings.Default.brushCanvasHighlightFg = Settings.Default.brushCanvasHighlightFgDefault;
            Settings.Default.brushCanvasBounds = Settings.Default.brushCanvasBoundsDefault;

            Settings.Default.brushCaret = Settings.Default.brushCaretDefault;

            Settings.Default.brushInfobarFg = Settings.Default.brushInfobarFgDefault;
            Settings.Default.brushInfobarBg = Settings.Default.brushInfobarBgDefault;
            #endregion
        }

        private void WritePreferences()
        {
            MainWindow m = mainWindow;

            #region Colors
            Settings.Default.brushWindowBg = classes.ColorConverter.ToDrawingColor(m.brushWindowBg.Color);
            Settings.Default.brushCanvasFg = classes.ColorConverter.ToDrawingColor(m.brushCanvasFg.Color);
            Settings.Default.brushCanvasBg = classes.ColorConverter.ToDrawingColor(m.brushCanvasBg.Color);
            #endregion
        }


        private void Application_Exit(object sender, ExitEventArgs e)
        {

            // MessageBox.Show("Exit");

            /*
            string var = Settings.Default["user"].ToString();
            MessageBox.Show(var);

            Settings.Default["user"] = "fipsi";
            var = Settings.Default["user"].ToString();
            MessageBox.Show(var);
            */

            // save settings
            Settings.Default.Save();
        }
    }
}
